.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include button.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax
    invoke InitCommonControls
    
    ; Create brushes for custom colors
    invoke CreateSolidBrush, CR_BACKGROUND
    mov hBgColor, eax
    invoke CreateSolidBrush, CR_INPUT
    mov hInColor, eax
    invoke CreatePen, PS_INSIDEFRAME, 1, CR_FOREGROUND
    mov hEdge, eax
    invoke CreatePen, PS_INSIDEFRAME, 1, CR_INPUT2 
    mov hEdge2, eax
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	
; Restore the memory used for graphic objects
    invoke DeleteObject, hEdge
    invoke DeleteObject, hInColor
    invoke DeleteObject, hIn2Color
    invoke DeleteObject, hFgColor
    invoke DeleteObject, hBgColor
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
	         invoke LoadIcon,hInstance,1000
	         mov hIcon,eax
             invoke CreateWindowEx,NULL, ADDR ButtonClassName,NULL,WS_CHILD or WS_VISIBLE or BS_ICON or BS_OWNERDRAW,\
             20,20,110,20,hWin,10,hInstance,NULL
invoke SendMessage,eax,BM_SETIMAGE,IMAGE_ICON,hIcon
             invoke SetDlgItemText,hWin,10,addr ButtonClassName

    .elseif uMsg == WM_DRAWITEM
             invoke DrawItem, hWin, lParam
    
	.elseif eax==WM_COMMAND

	.elseif eax==WM_CLOSE
		    invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp
DrawItem PROC hWnd: HWND, lParam: LPARAM
  push esi
  mov esi, lParam
  assume esi: ptr DRAWITEMSTRUCT

;buttons color
    INVOKE SelectObject, [esi].hdc, hInColor


;frame color
.IF [esi].itemState & ODS_SELECTED
   INVOKE SelectObject, [esi].hdc, hEdge2
  .ELSE
    INVOKE SelectObject, [esi].hdc, hEdge
  .ENDIF


  INVOKE FillRect, [esi].hdc, ADDR [esi].rcItem, hBgColor
  INVOKE RoundRect, [esi].hdc, [esi].rcItem.left, [esi].rcItem.top, [esi].rcItem.right, [esi].rcItem.bottom, 6, 6

  .IF [esi].itemState & ODS_SELECTED
    INVOKE OffsetRect, ADDR [esi].rcItem, 1, 1
  .ENDIF

  ; Write the text
  INVOKE GetDlgItemText, hWnd, [esi].CtlID, ADDR sBtnText, SIZEOF sBtnText
  INVOKE SetBkMode, [esi].hdc, TRANSPARENT


;textcolor
  .IF [esi].itemState & ODS_SELECTED
      INVOKE SetTextColor, [esi].hdc, CR_INPUT2
  .ELSE
      INVOKE SetTextColor, [esi].hdc, CR_HIGHLIGHT
  .ENDIF

  INVOKE DrawText, [esi].hdc, ADDR sBtnText, -1, ADDR [esi].rcItem, DT_CENTER or DT_VCENTER or DT_SINGLELINE

  .IF [esi].itemState & ODS_SELECTED
    INVOKE OffsetRect, ADDR [esi].rcItem, -1, -1
  .ENDIF

  ; Draw the focus rectangle
  .IF [esi].itemState & ODS_FOCUS
    INVOKE InflateRect, ADDR [esi].rcItem, -3, -3
    ;INVOKE DrawFocusRect, [esi].hdc, ADDR [esi].rcItem
  .ENDIF

  assume esi:nothing
  pop esi
  mov eax, TRUE
  ret
DrawItem ENDP
end start
